<template>
  <div v-if="registered_gender !== 0">
    <GChart
      v-loading="loading"
      type="PieChart"
      :data="chartData"
      :options="chartOptions"
      :resizeDebounce="500"
      :key="rerender"
      @ready="onChartReady"
    />
  </div>
</template>
<script>
import { GChart } from 'vue-google-charts';
export default {
  name: 'GenderChart',
  components: {
    GChart
  },
  data() {
    return {
      chartData: null,
      loading: true,
      rerender: 0
    };
  },
  computed: {
    registered_gender: {
      get: function() {
        return this.$store.getters.registered_gender;
      }
    },
    chartOptions() {
      return {
        animation: {
          duration: 10000,
          easing: 'out',
          startup: true
        },
        chart: {
          title: 'Farmer chart by gender',
          subtitle: 'Jenis kelamin'
        },
        height: 500,
        pieHole: 0.5,
        pieSliceText: 'none',
        slices: [{ color: '#76be40' }, { color: '#f9bc3f' }, { color: '#086939' }, { color: '#b9e4ac' }],
        legend: {
          position: 'labeled',
          align: 'center',
          textStyle: {
            color: { color: '#76be40' }
          }
        },
        tooltip: {
          ignoreBounds: true,
          isHtml: true,
          trigger: 'selection'
        }
      };
    }
  },
  watch: {
    registered_gender(newGender, oldGender) {
      this.dataGender = newGender;
      this.rerender = this.rerender + 1;
    }
  },
  methods: {
    onChartReady(chart, google) {
      this.createDataTable(chart, google);
      this.loading = true;
      setTimeout(() => {
        this.loading = false;
      }, 1.5 * 1000);
    },
    createDataTable(chart, google) {
      const dataTable = new google.visualization.DataTable();

      this.dataGender = this.registered_gender;

      dataTable.addColumn('string', 'Gender');
      dataTable.addColumn('number', 'Value');
      dataTable.addColumn({ type: 'string', role: 'tooltip', p: { html: true } });

      const maleSymbol = 'https://user-core.s3-ap-southeast-1.amazonaws.com/assets/male-symbol.png';
      const femaleSymbol = 'https://user-core.s3-ap-southeast-1.amazonaws.com/assets/female-symbol.png';

      this.dataGender.forEach(el => {
        dataTable.addRows([
          [
            el.gender,
            el.farmer_count,
            customTooltip(
              `<img class="gender-tooltip__featured" src="${
                el.gender === 'Pria' ? maleSymbol : femaleSymbol
              }" style="background:${el.gender === 'Pria' ? '#76be40' : '#f9bc3f'};"/>`,
              el.gender,
              el.percent,
              el.farmer_count
            )
          ]
        ]);
      });

      function customTooltip(icon, gender, percent, value) {
        return (
          '<div class="gender-tooltip">' +
          '<table class="gender-tooltip__box">' +
          '<tr>' +
          '<td><b>' +
          percent +
          '% </b></td>' +
          '<td><span><b>' +
          value +
          '</b><img src="https://user-core.s3-ap-southeast-1.amazonaws.com/assets/people-dark-green.svg" /></span></td>' +
          '<td><b>' +
          gender +
          '</b></td>' +
          '<td rowspan="2">' +
          icon +
          '</td>' +
          '</tr>' +
          '</table></div>'
        );
      }

      this.chartData = dataTable;

      chart.draw(dataTable, this.chartOptions);
    }
  }
};
</script>
<style rel="stylesheet/scss" lang="scss" >
@import '@/styles/variables.scss';
@import '@/styles/mixin.scss';
.google-visualization-tooltip {
  border: none !important;
  box-shadow: none !important;
}
.gender-tooltip {
  display: block;
  padding: 10px;
  @include ritx-box;

  &__box {
    span {
      display: inline-flex;
      align-items: center;
    }
  }

  .gender-tooltip__featured {
    width: 40px;
    height: 40px;
  }

  table {
    td {
      vertical-align: middle;
      font-size: 18px;
      a {
        font-size: 18px;
        display: inline-flex;
        align-items: center;
        color: #f9bc3f;
      }
    }
  }

  img {
    padding: 5px;
    width: 25px;
    height: 25px;
  }
}
</style>
